#ifndef __APPLICATIONPROCESS_H
#define __APPLICATIONPROCESS_H


#include "atomic.h"     // class Atomic

class ApplicationProcess : public Atomic
{
public:
	ApplicationProcess( const string &name = "ApplicationProcess" );					//Default constructor

	virtual string className() const ;

protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &applicationProcessIN;
	//const Port &notifyDone;
	Port &applicationProcessOUT;
	Port &applicationProcessStatus;
	Time applicationProcessTime;
	int tempNum;
	int checkNum;
};

// ** inline ** //

inline string ApplicationProcess::className() const
{
	return "ApplicationProcess" ;
}

#endif   //__ApplicationProcess_H
