#ifndef __REGISTRAR_H
#define __REGISTRAR_H


#include "atomic.h"     // class Atomic

class Registrar : public Atomic
{
public:
	Registrar ( const string &name = "Registrar" );					//Default constructor

	virtual string className() const ;

protected:
	Model &initFunction();
	Model &externalFunction( const ExternalMessage & );
	Model &internalFunction( const InternalMessage & );
	Model &outputFunction( const InternalMessage & );

private:
	const Port &applicationVerificationIN;
	Port &applicationVerificationOUT;
	Port &minStandardsNotMet;
	Time registrarTime;
	int  studentGrade;
	int  checkNum;
	bool lowGrade;
};

// ** inline ** //

inline string Registrar::className() const
{
	return "Registrar" ;
}

#endif   //__Registrar_H
